<template>
  <ul v-if="totalPages > 1" class="pagination">
    <li v-show="currentPage > 1">
      <nuxt-link :to="mergeQuery({ page: currentPage - 1 })">
        Предыдущая
      </nuxt-link>
    </li>
    <template v-if="totalPages > 2">
      <li v-for="number in totalPages" :key="number">
        <nuxt-link :to="mergeQuery({ page: number })">
          {{ number }}
        </nuxt-link>
      </li>
    </template>
    <li v-show="currentPage < totalPages">
      <nuxt-link :to="mergeQuery({ page: currentPage + 1 })">
        Следующая
      </nuxt-link>
    </li>
  </ul>
</template>

<script>
import { mergeQuery } from '@/mixins/utils'
export default {
  name: 'BasePagination',
  props: {
    totalPages: {
      type: Number,
      required: true,
    },
  },
  computed: {
    currentPage() {
      let result = 1

      const { page } = this.$route.query
      if (page >= 0) {
        result = parseInt(page)
      }
      this.$emit('change', result)
      return result
    },
    mergeQuery() {
      return (query) => {
        if (query.page === 1) {
          const to = mergeQuery.bind(this, query)()
          delete to.query.page
          return to
        }
        return mergeQuery.bind(this, query)()
      }
    },
  },
}
</script>
